function [c,ceq] = mycon(x,nlv,nlength,JXXJ,nobs,dtype)
% The constraints function used in Functional GSCA written in MATLAB R2014a
% last modified: Feb 28, 2016

for i = 1:nlv
    if i == 1
        w{i} = x(1:nlength(i),1);
    else w{i} = x(sum(nlength(1:i-1))+1:sum(nlength(1:i)),1);
    end
    
    if dtype(i)~=3
        ceq(i) = w{i}'*JXXJ{i}*w{i} - nobs;
    end;
end
c = [];