function f = myfun(x,nlv,nlength,dtype,X,J,JXXJ,R,B,c,lambdaw)
% The objective function used in Functional GSCA written in MATLAB R2014a
% last modified: Feb 28, 2016


f = 0;
for i = 1:nlv
    if i == 1
        w{i} = x(1:nlength(1),1);
    else w{i} = x(sum(nlength(1:i-1))+1:sum(nlength(1:i)),1);
    end
    Gamma(:,i) = X{i}*J{i}*w{i};
    
    if dtype(i) == 1
        f = f -2*w{i}'*JXXJ{i}*c{i} + c{i}'*J{i}*c{i}*w{i}'*JXXJ{i}*w{i} + lambdaw*w{i}'*R{i}*w{i};
    else f = f -2*w{i}'*JXXJ{i}*c{i} + c{i}'*J{i}*c{i}*w{i}'*JXXJ{i}*w{i};
    end
end

f = f + trace((Gamma-Gamma*B)'*(Gamma-Gamma*B));


